
app.d0 = cs.clazz({
    protos: {
        create: function () {
            /*  create sub-components  */
            cs(this).create("d1", app.d1)
            cs(this).create("d2", app.d2)

            /*  allow us and sub-components to automatically increase state  */
            cs(this).property("ComponentJS:state-auto-increase", true)
        },
        prepare: function () {
            /*  if component d1 was clicked, let d2 toggle its color  */
            var self = this
            cs(this).subscribe({
                name: "d1-clicked",
                spool: "prepared",
                func: function () {
                    cs(self, "d2").call("toggle-color")
                }
            })
        },
        render: function () {
            /*  materialize UI structure  */
            var ui = $.parseHTML(
                '<div class="app">' +
                    'Hello from d0!<br/>' +
                    '<div class="one"></div>' +
                    '<div class="two"></div>' +
                '</div>'
            );

            /*  place UI structure into DOM  */
            $("body").html(ui)

            /*  provide sockets to allow sub-components to plug into our UI  */
            cs(this).socket({ scope: "d1", ctx: $("div.one", ui), type: "jquery" })
            cs(this).socket({ scope: "d2", ctx: $("div.two", ui), type: "jquery" })
        },
        release: function () {
            /*  remove UI structure from DOM  */
            $("body").html("")
        },
        cleanup: function () {
            /*  remove event subscription  */
            cs(this).unspool("prepared")
        }
    }
})

