
app.d1 = cs.clazz({
    mixin: [ cs.marker.controller ],
    protos: {
        create: function () {
            /*  create our model and view  */
            cs(this).create(
                "d1-model/d1-view", 
                app.d1.model, app.d1.view
            )
        },
        prepare: function () {
            var self = this

            /*  event bind to presentation model click event  */
            cs(self, "d1-model").observe({
                name: "event:clicked",
                spool: "controller-prepared",
                func: function (ev) {
                    cs(self).publish("d1-clicked")
                }
            })
        },
        cleanup: function () {
            cs(this, "d1-model").unspool("controller-prepared")
        }
    }
})

app.d1.model = cs.clazz({
    mixin: [ cs.marker.model ],
    protos: {
        create: function () {
            /*  create our presentation model  */
            cs(this).model({
                "data:label":    { value: "Hello from d1!", valid: "string" },
                "event:clicked": { value: false, valid: "boolean", autoreset: true }
            })
        }
    }
})

app.d1.view = cs.clazz({
    mixin: [ cs.marker.view ],
    protos: {
        render: function () {
            /*  materialize UI structure  */
            var ui = $.parseHTML('<div class="d1"></div>')

            /*  plug into DOM of parent  */
            cs(this).plug({ object: ui, spool: "materialized" })

            /*  react on UI DOM click event and
                publish this as a presentation model event */
            var self = this
            $(ui).click(function () {
                cs(self).value("event:clicked", true)
            })

            /*  data bind the text label  */
            cs(this).observe({
                name: "data:label",
                spool: "materialized",
                touch: true,
                func: function (ev, label) {
                    $(ui).html(label)
                }
            })
        },
        release: function () {
            /*  unplug from DOM of parent and unobserve model  */
            cs(this).unspool("materialized")
        }
    }
})

