
app.d2 = cs.clazz({
    mixin: [ cs.marker.controller ],
    protos: {
        create: function () {
            /*  create our model and view  */
            cs(this).create(
                "d2-model/d2-view",
                app.d2.model, app.d2.view
            )
        },
        prepare: function () {
            var self = this

            /*  provide service for color toggling  */
            cs(self).register({
                name: "toggle-color",
                spool: "prepared",
                func: function () {
                    var color = cs(self, "d2-model").value("state:color")
                    cs(self, "d2-model").value("state:color", color !== 1 ? 1 : 2)
                }
            })

            /*  state bind the color  */
            cs(self, "d2-model").observe({
                name: "state:color",
                spool: "controller-prepared",
                func: function (ev, color) {
                    var date = new Date()
                    if (   typeof console !== "undefined" 
                        && typeof console.log === "function")
                        console.log(date + ": d2: changed to color #" + color)
                }
            })
        },
        cleanup: function () {
            cs(this).unspool("prepared")
            cs(this, "d2-model").unspool("controller-prepared")
        }
    }
})

app.d2.model = cs.clazz({
    mixin: [ cs.marker.model ],
    protos: {
        create: function () {
            /*  create our presentation model  */
            cs(this).model({
                "data:label":  { value: "Hello from d2!", valid: "string" },
                "state:color": { value: 1, valid: "number" },
            })
        }
    }
})

app.d2.view = cs.clazz({
    mixin: [ cs.marker.view ],
    protos: {
        render: function () {
            /*  materialize UI structure  */
            var ui = $.parseHTML('<div class="d2"></div>')

            /*  plug into DOM of parent  */
            cs(this).plug({ object: ui, spool: "materialized" })

            /*  data bind the text label  */
            cs(this).observe({
                name: "data:label",
                spool: "materialized",
                touch: true,
                func: function (ev, label) {
                    $(ui).html(label)
                }
            })

            /*  state bind the color  */
            cs(this).observe({
                name: "state:color",
                spool: "materialized",
                touch: true,
                func: function (ev, color) {
                    $(ui)
                        .removeClass("color1")
                        .removeClass("color2")
                        .addClass("color" + color)
                }
            })
        },
        release: function () {
            /*  unplug from DOM of parent and unobserve model  */
            cs(this).unspool("materialized")
        }
    }
})

