
app.d2 = cs.clazz({
    mixin: [ cs.marker.controller ],
    protos: {
        create: function () {
            /*  create our model and view  */
            cs(this).create(
                "dx-model/dx-view",
                app.dx.model, app.dx.view
            )
        },
        prepare: function () {
            var self = this

            /*  provision data into model  */
            cs(self, "dx-model").value("data:label", "Hello from d2!")

            /*  provide service for color toggling  */
            cs(self).register({
                name: "toggle-color",
                spool: "prepared",
                func: function () {
                    var color = cs(self, "dx-model").value("state:color")
                    cs(self, "dx-model").value("state:color", color !== 1 ? 1 : 2)
                }
            })

            /*  state bind the color  */
            cs(self, "dx-model").observe({
                name: "state:color",
                spool: "controller-prepared",
                func: function (ev, color) {
                    var date = new Date()
                    if (   typeof console !== "undefined" 
                        && typeof console.log === "function")
                        console.log(date + ": d2: changed to color #" + color)
                }
            })
        },
        cleanup: function () {
            cs(this).unspool("prepared")
            cs(this, "dx-model").unspool("controller-prepared")
        }
    }
})

