
cs.ns("app.dx")

app.dx.model = cs.clazz({
    mixin: [ cs.marker.model ],
    protos: {
        create: function () {
            /*  create our presentation model  */
            cs(this).model({
                "data:label":      { value: "Hello from dx!", valid: "string" },
                "state:color":     { value: 1, valid: "number" },
                "param:clickable": { value: false, valid: "boolean" },
                "event:clicked":   { value: false, valid: "boolean", autoreset: true }
            })
        }
    }
})

app.dx.view = cs.clazz({
    mixin: [ cs.marker.view ],
    protos: {
        render: function () {
            /*  materialize UI structure  */
            var ui = $.parseHTML('<div class="dx"></div>')

            /*  plug into DOM of parent  */
            cs(this).plug({ object: ui, spool: "materialized" })

            /*  optionally react on UI DOM click event and
                publish this as a presentation model event */
            if (cs(this).value("param:clickable")) {
                var self = this
                $(ui).click(function () {
                    cs(self).value("event:clicked", true)
                })
            }

            /*  data bind the text label  */
            cs(this).observe({
                name: "data:label",
                spool: "materialized",
                touch: true,
                func: function (ev, label) {
                    $(ui).html(label)
                }
            })

            /*  state bind the color  */
            cs(this).observe({
                name: "state:color",
                spool: "materialized",
                touch: true,
                func: function (ev, color) {
                    $(ui)
                        .removeClass("color0")
                        .removeClass("color1")
                        .removeClass("color2")
                        .removeClass("color3")
                        .addClass("color" + color)
                }
            })
        },
        release: function () {
            /*  unplug from DOM of parent and unobserve model  */
            cs(this).unspool("materialized")
        }
    }
})

